﻿
function icon1(contid, objprop, title, refreshtime){
  this.title = title;
  this.title_font = 'bold 36px Tahoma';
  this.color = 'white';
  this.alertcolor = 'red';
  this.background = 'rgba(100,160,230,1)';
  this.marker_font = 'bold 8px Tahoma';
  
  this.contid = contid;
  this.objprop = objprop;
  this.refreshtime = refreshtime;
  
  this.redraw = function(){   
	if (!this.context) {
		return;
	}  
	  
    // Value
	this.context.clearRect(0, 0, 50, 50);
	
    // Rect
    this.context.fillStyle = this.background;
    this.context.fillRoundedRect(0, 0, 50, 50, 10);
	
	if (this.drawmarker) {
	  this.drawmarker();
	  
	  this.context.fillStyle = this.color;  
	  this.context.font = this.marker_font;
	  this.context.fillText( this.GetDirection(), 8, 8); 
	}

	this.context.textAlign = "center";  	

    // Value  	
    if (this.value != ''){    
	  if (this.value == 0) {
	    this.context.fillStyle = this.alertcolor;
	  } else {
	    this.context.fillStyle = this.color;
	  }
      this.elem.title = this.valupdated;
      this.context.font = this.title_font;
      this.context.fillText(this.title, 25, 38);
    }
  } 
  
  this.drawmarker = function(){
	if (!this.context) {
		return;
	}  
	  
    if (this.eventState == ''){
	  this.context.fillStyle = 'green';
	} else {
  	  if (this.eventState == 'processing'){
	    this.context.fillStyle = 'black';
	  } else {
	    this.context.fillStyle = 'yellow';          
	  }
	}
	
	this.context.font = this.marker_font;
	this.context.textAlign = "left";  
    this.context.fillText('•', 2, 8); 
  }  
    
  this.init( ); 
}

icon1.prototype = new s2_alertobject();