
function smartStick1(contid, objprop, title, refreshtime, measure){        
  this.title = title;
  this.measure = measure;
  
  this.title_font = 'bold 10px Tahoma';
  this.value_font = 'bold 14px Tahoma';
  this.color = 'white';
  this.alertcolor = 'red';
  this.background1 = "rgba(100,200,100,1)";
  this.background2 = "rgba(120,120,120,1)";
  this.marker_font = 'bold 10px Tahoma';
  
  if (this.measure == '') {
    this.measure = '°';
  }  
  
  this.contid = contid;
  this.objprop = objprop;
  this.refreshtime = refreshtime;
  
  this.redraw = function(){
  	if (!this.context) {
		return;
	}  
	
    // Value
	this.context.clearRect(0, 0, 75, 55);
	
	// Rect
	this.context.fillStyle = this.background1;
	this.context.fillRoundedRect(0, 0, 75, 55, 10);
  
	this.context.fillStyle = this.background2;
	this.context.fillRect(0, 35, 75, 10);
	this.context.fillRoundedRect(0, 35, 75, 20, 10);
	
	if (this.drawmarker) {
	  this.drawmarker();
	  	  
	  this.context.fillStyle = this.color;  
	  this.context.font = this.marker_font;
	  this.context.fillText( this.GetDirection(), 8, 10); 
	}
  
	this.context.textAlign = "center";  
  
    // Value  	
    if (this.value != ''){    
	  if ((this.alertstate != 0) && (this.alertframe == 0) ) {
	    this.context.fillStyle = this.alertcolor;
	  } else {
	    this.context.fillStyle = this.color;
	  }
      this.elem.title = this.valupdated;
      this.context.font = this.value_font;
      this.context.fillText(this.value+this.measure, 38, 25, 65);
    }

    // Title
	this.context.fillStyle = this.color;
    this.context.font = this.title_font;
    this.context.fillText(this.title, 38, 50, 65); 	
  } 
  
  this.drawmarker = function(){
	if (!this.context) {
		return;
	}  
	  
    if (this.eventState == ''){
	  this.context.fillStyle = 'green';
	} else {
  	  if (this.eventState == 'processing'){
	    this.context.fillStyle = 'black';
	  } else {
	    this.context.fillStyle = 'yellow';          
	  }
	}
	
	this.context.font = this.marker_font;
	this.context.textAlign = "left";  
    this.context.fillText('•', 2, 10); 
  }
  
  this.init( );
}

smartStick1.prototype = new s2_alertobject();