
function Stick1b(contid, objprop, title, refreshtime, measure){        
  this.title = title;
  this.measure = measure;
  
  this.title_font = 'bold 10px Tahoma';
  this.value_font = 'bold 14px Tahoma';
  this.color = 'white';
  this.alertcolor = 'red';
  this.background = 'rgba(100,160,230,1)';
  this.marker_font = 'bold 10px Tahoma';
  
  if (this.measure == '') {
    this.measure = '°';
  }  
  
  this.contid = contid;
  this.objprop = objprop;
  this.refreshtime = refreshtime;
  
  this.redraw = function(){
	if (!this.context) {
		return;
	}  
	  
	// Value
	this.context.clearRect(0, 0, 60, 60);  
	
    // Rect
    this.context.fillStyle = this.background;
    this.context.fillRoundedRect(0, 0, 60, 60, 10);

    // Div
    this.context.strokeStyle = this.color;
    this.context.lineWidth = 2, 
    this.context.moveTo(8,35);
    this.context.lineTo(52,35);
    this.context.stroke();
	
	if (this.drawmarker) {
	  this.drawmarker();
	  
	  this.context.fillStyle = this.color;
	  this.context.font = this.marker_font;
	  this.context.fillText( this.GetDirection(), 10, 10); 
	}

	this.context.textAlign = "center";  	

    // Value  	
    if (this.value != ''){    	
	  if ((this.alertstate != 0) && (this.alertframe == 0) ) {
	    this.context.fillStyle = this.alertcolor;
	  } else {
	    this.context.fillStyle = this.color;
	  }
      this.elem.title = this.valupdated;	  
      this.context.font = this.value_font;
      this.context.fillText(this.value+this.measure, 30, 25, 55);
    }

    // Title
	this.context.fillStyle = this.color;
    this.context.font = this.title_font;
    this.context.fillText(this.title, 30, 50, 55);	
  } 
  
  this.drawmarker = function(){
	if (!this.context) {
		return;
	}  
	  
    if (this.eventState == ''){
	  this.context.fillStyle = 'green';
	} else {
  	  if (this.eventState == 'processing'){
	    this.context.fillStyle = 'black';
	  } else {
	    this.context.fillStyle = 'yellow';          
	  }
	}
	
	this.context.font = this.marker_font;
	this.context.textAlign = "left";  
    this.context.fillText('•', 2, 10); 
  }  
  
  this.init( );
}

Stick1b.prototype = new s2_alertobject();